Public Class Form1
    Const CtrlMask As Byte = 8

    Private Sub Form1_Load( _
       ByVal sender As System.Object, _
       ByVal e As System.EventArgs) _
       Handles MyBase.Load
        '---set the control to allow drop---
        TextBox1.AllowDrop = True

        '---set the control to allow drop---
        With PictureBox1
            .AllowDrop = True
            .BorderStyle = BorderStyle.FixedSingle
            .SizeMode = PictureBoxSizeMode.StretchImage
        End With

        '---set the control to allow drop---
        With PictureBox2
            .AllowDrop = True
            .BorderStyle = BorderStyle.FixedSingle
            .SizeMode = PictureBoxSizeMode.StretchImage
        End With
        MediaPlayer1.AllowDrop = True
    End Sub

    Private Sub TextBox1_DragDrop( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles TextBox1.DragDrop
        '---if the data to be dropped is a text format---
        If (e.Data.GetDataPresent(DataFormats.Text)) Then
            '---set the control to display the text being dropped---
            TextBox1.Text = e.Data.GetData(DataFormats.Text)
        End If
        '---set the borderstyle back to its original---
        TextBox1.BorderStyle = BorderStyle.Fixed3D
    End Sub

    Private Sub TextBox1_DragEnter( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles TextBox1.DragEnter

        '---if the data to be dropped is a text format---
        If (e.Data.GetDataPresent(DataFormats.Text)) Then
            '---determine if this is a copy or move---
            If (e.KeyState And CtrlMask) = CtrlMask Then
                e.Effect = DragDropEffects.Copy
            Else
                e.Effect = DragDropEffects.Move
            End If
            '---change the border style of the control---
            TextBox1.BorderStyle = BorderStyle.FixedSingle
        End If
    End Sub

    Private Sub TextBox1_DragLeave( _
       ByVal sender As Object, _
       ByVal e As System.EventArgs) _
       Handles TextBox1.DragLeave
        '---set the borderstyle back to its original---
        TextBox1.BorderStyle = BorderStyle.Fixed3D
    End Sub

    Private Sub PictureBox1_DragDrop( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles PictureBox1.DragDrop
        '---if the data to be dropped is a image format---
        If (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            '---set the control to display the bitmap being dropped---
            PictureBox1.Image = e.Data.GetData(DataFormats.Bitmap)

        ElseIf (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            Dim files() As String
            files = e.Data.GetData(DataFormats.FileDrop)
            For Each file As String In files
                file = UCase(file)
                If file.EndsWith(".GIF") Or _
                   file.EndsWith(".JPG") Or _
                   file.EndsWith(".BMP") Then
                    PictureBox1.Image = New Bitmap(file)
                End If
                System.Threading.Thread.Sleep(2000)
                Application.DoEvents()
            Next

        ElseIf (e.Data.GetDataPresent(DataFormats.Rtf)) Then
            '---display the rich text---
            Console.WriteLine(e.Data.GetData(DataFormats.Rtf))
        End If
        '---set the borderstyle back to its original---
        PictureBox1.BorderStyle = BorderStyle.FixedSingle
    End Sub

    Private Sub PictureBox1_DragEnter( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles PictureBox1.DragEnter

        Dim formats As String() = e.Data.GetFormats

        '---if the data to be dropped is an image format---
        If (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            '---determine if this is a copy or move---
            If (e.KeyState And CtrlMask) = CtrlMask Then
                e.Effect = DragDropEffects.Copy
            Else
                e.Effect = DragDropEffects.Move
            End If
            '---change the border style of the control---
            PictureBox1.BorderStyle = BorderStyle.Fixed3D

        ElseIf (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            '---if this is a file drop---
            e.Effect = DragDropEffects.All

        ElseIf (e.Data.GetDataPresent(DataFormats.Rtf)) Then
            '---determine if this is a copy or move---
            If (e.KeyState And CtrlMask) = CtrlMask Then
                e.Effect = DragDropEffects.Copy
            Else
                e.Effect = DragDropEffects.Move
            End If
            '---change the border style of the control---
            PictureBox1.BorderStyle = BorderStyle.Fixed3D
        End If
    End Sub

    Private Sub PictureBox1_DragLeave( _
       ByVal sender As Object, _
       ByVal e As System.EventArgs) _
       Handles PictureBox1.DragLeave
        '---set the borderstyle back to its original---
        PictureBox1.BorderStyle = BorderStyle.FixedSingle
    End Sub

    Private Sub PictureBox1_MouseDown( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.MouseEventArgs) _
       Handles PictureBox1.MouseDown
        If PictureBox1.Image IsNot Nothing Then
            PictureBox1.DoDragDrop( _
               PictureBox1.Image, _
               DragDropEffects.Move Or DragDropEffects.Copy)
        End If
    End Sub

    Private Sub PictureBox1_QueryContinueDrag( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.QueryContinueDragEventArgs) _
       Handles PictureBox1.QueryContinueDrag

        Console.WriteLine(e.Action.ToString)
        If e.Action = DragAction.Drop Then
            If (e.KeyState And CtrlMask) <> CtrlMask Then
                '---a move operation---
                PictureBox1.Image = Nothing
            End If
        End If
    End Sub

    Private Sub PictureBox2_DragDrop( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles PictureBox2.DragDrop
        '---if the data to be dropped is a bitmap format---
        If (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            '---set the control to display the bitmap being dropped---
            PictureBox2.Image = e.Data.GetData(DataFormats.Bitmap)
        End If
        '---set the borderstyle back to its original---
        PictureBox2.BorderStyle = BorderStyle.FixedSingle
    End Sub

    Private Sub PictureBox2_DragEnter( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles PictureBox2.DragEnter
        '---if the data to be dropped is an image format---
        If (e.Data.GetDataPresent(DataFormats.Bitmap)) Then
            '---determine if this is a copy or move---
            If (e.KeyState And CtrlMask) = CtrlMask Then
                e.Effect = DragDropEffects.Copy
            Else
                e.Effect = DragDropEffects.Move
            End If
            '---change the border style of the control---
            PictureBox2.BorderStyle = BorderStyle.Fixed3D
        End If
    End Sub

    Private Sub PictureBox2_DragLeave( _
       ByVal sender As Object, _
       ByVal e As System.EventArgs) _
       Handles PictureBox2.DragLeave
        '---set the borderstyle back to its original---
        PictureBox2.BorderStyle = BorderStyle.FixedSingle
    End Sub

    Private Sub MediaPlayer1_DragDrop( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles MediaPlayer1.DragDrop
        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            Dim files() As String
            '---get all the file names---
            files = e.Data.GetData(DataFormats.FileDrop)

            If files.Length > 0 Then
                '---load only the first file---
                files(0) = UCase(files(0))
                If files(0).EndsWith(".WMV") Then
                    '---get the media player to play the first file---
                    MediaPlayer1.URL = files(0)
                End If
            End If
        End If
    End Sub

    Private Sub MediaPlayer1_DragEnter( _
       ByVal sender As Object, _
       ByVal e As System.Windows.Forms.DragEventArgs) _
       Handles MediaPlayer1.DragEnter
        '---if the data to be dropped is an filedrop format---
        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            '---determine if this is a copy or move---
            If (e.KeyState And CtrlMask) = CtrlMask Then
                e.Effect = DragDropEffects.Copy
            Else
                e.Effect = DragDropEffects.Move
            End If
        End If
    End Sub

    Private Sub PictureBox1_GiveFeedback(ByVal sender As Object, ByVal e As System.Windows.Forms.GiveFeedbackEventArgs) Handles PictureBox1.GiveFeedback
        Console.WriteLine(e.Effect.ToString)
    End Sub
End Class
